<#assign view_base_name>PickupTreeViewBase</#assign>
<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.template.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_HEADER-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_CONTENT-BASE.vue.ftl
</#ibizinclude>
    /**
     * 选中数据字符串
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop() public selectedData?: string;

    /**
     * 是否单选
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop() public isSingleSelect?: boolean;

    /**
     * 是否显示按钮
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Prop({default: true}) public isShowButton!: boolean;

    /**
     * 节点过滤值
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public srfnodefilter: string = '';

    /**
     * 快速搜索
     *
     * @returns {void}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public onSearch(): void {
        if (!this.viewState) {
            return;
        }
        <#if view.hasPSControl('tree')>
        this.viewState.next({ tag: '${view.getPSControl('tree').name}', action: 'filter', data: { srfnodefilter: this.srfnodefilter } });
        </#if>
    }

    /**
     * tree 部件 nodedblclick 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public tree_nodedblclick($event: any, $event2?: any) {
        this.engine.onCtrlEvent('tree', 'nodedblclick', $event);
    }

<#ibizinclude>
../@MACRO/VIEW_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW-BASE.style.ftl
</#ibizinclude>